/**
 * Copyright (c) 2003
 * Template File
 *   InterfaceServerImpl.java.template
 * IDL Object
 *   javacorba.CustService.Customer
 * Generation Date
 *   Sunday, April 27, 2003 6:05:08 AM CDT
 * IDL Source File
 *   /root/JBuilderProjects/JavaCorba/src/javacorba/Customer.idl
 * Abstract
 *   Provides default implementation for the server side of a CORBA interface.
 * @version 1.0
 */

package javacorba.CustService.server;

import java.sql.*;
import java.util.*;

import org.omg.PortableServer.*;

public class CustomerImpl
    extends javacorba.CustService.CustomerPOA {
  String _name = "Customer";
  public static ServerMonitorPage monitor = null;

  // lines added manually - begin
  Properties custList = new Properties();
  Random rand = new Random(System.currentTimeMillis());
  // lines added manually - end

  private void init() {
    if (monitor == null) {
      monitor = ServerMonitor.addPage(this, "Customer");
      monitor.showObjectCounter(true);
    }
    monitor.updateObjectCounter(1);

  }

  public CustomerImpl(java.lang.String name,
                      java.lang.String creationParameters) {
    this._name = name;

    init();
  }

  public CustomerImpl(java.lang.String name) {
    this._name = name;
    init();
  }

  public CustomerImpl() {
    init();
  }

  public int AddCustomer(String CustName) {
    ServerMonitor.log("(" + _name + ") CustomerImpl.java AddCustomer()");
    // lines added manually - begin
    int nextCustID = 0;
    try {
      ServerMonitor.log("Customer Name : "+CustName);
      nextCustID = getNextCustID();
      if (!custList.contains(String.valueOf(nextCustID))) {
        custList.put(String.valueOf(nextCustID), CustName);
      }
    }
    catch (Exception ex) {
      ServerMonitor.log("Exception while generating new customer number");
    }
    return nextCustID;
    // lines added manually - end
  }

  public String GetCustomer(int CustId) {
    ServerMonitor.log("(" + _name + ") CustomerImpl.java GetCustomer()");
    // lines added manually - begin
    String custName = "";
    try {
      custName = (String)custList.get(String.valueOf(CustId));
    }
    catch (Exception ex) {
      ServerMonitor.log("Exception while retrieving customer name for a customer ID");
    }
    return custName;
    // lines added manually - end
  }

  // lines added manually - begin
  public int getNextCustID() {
    int nextCustID = 0;
    try {
      nextCustID = rand.nextInt();
      ServerMonitor.log("Next Cust ID is " + nextCustID);
      if (nextCustID < 0)
        nextCustID = -nextCustID;
      ServerMonitor.log("Next Cust ID is " + nextCustID);
    }
    catch (Exception ex) {
      ServerMonitor.log("Exception while generating new customer number");
    }
    return nextCustID;
  }
  // lines added manually - end
}

