/**
 * Copyright (c) 2003
 * Template File
 *   ServerMonitor.java.template
 * IDL Object
 *   javacorba.CustService
 * Generation Date
 *   Sunday, April 27, 2003 6:05:12 AM CDT
 * IDL Source File
 *   /root/JBuilderProjects/JavaCorba/src/javacorba/Customer.idl
 * Abstract
 *   Maintains the server log and is the container for all the Server Monitor pages.
 * @version 1.0
 */

package javacorba.CustService.server;

import java.awt.*;
import java.text.*;

public class ServerMonitor
    extends javax.swing.JPanel {
  static com.borland.dbswing.JdbTextArea myLog = null;
  static ServerMonitor monitor;
  java.util.ResourceBundle res = java.util.ResourceBundle.getBundle(
      "javacorba.CustService.server.ServerResources");
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  javax.swing.JTabbedPane tabPanel1 = new javax.swing.JTabbedPane();
  javax.swing.JPanel panel1 = new javax.swing.JPanel();

  BorderLayout moduleBorderLayoutCustService = new BorderLayout();
  javax.swing.JPanel panelCustService = new javax.swing.JPanel();
  com.borland.dbswing.JdbTextArea textCustService = new com.borland.dbswing.
      JdbTextArea();
  javax.swing.JScrollPane scrollCustService = new javax.swing.JScrollPane();
  java.util.Vector pagesToRefresh = new java.util.Vector();

  public ServerMonitor() {
    monitor = this;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    this.add(panel1, BorderLayout.CENTER);
    panel1.setLayout(borderLayout2);
    panel1.add(tabPanel1, BorderLayout.CENTER);

    textCustService.setEnabled(true);
    panelCustService.setLayout(moduleBorderLayoutCustService);
    scrollCustService.getViewport().add(textCustService);
    panelCustService.add(scrollCustService, BorderLayout.CENTER);
    myLog = textCustService;
    tabPanel1.addTab(ServerResources.format(res.getString("logTitle"),
                                            "CustService"), panelCustService);
    tabPanel1.setSelectedComponent(panelCustService);
  }

  private void addPage(ServerMonitorPage page, String name) {
    tabPanel1.addTab(name, page);
    pagesToRefresh.addElement(page);
    //panel1.updateUI();
    //tabPanel1.setEnabledAt(0, true);
  }

  private static ServerFrame createFrame() {
    ServerFrame frame = new ServerFrame();
    frame.pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation( (screenSize.width - frameSize.width) / 2,
                      (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);

    return (frame);
  }

  protected static void ensureFrame() {
    if (ServerMonitor.monitor == null) {
      ServerMonitor.monitor = new ServerMonitor();
      ServerFrame frame = createFrame();
      frame.getContentPane().add(ServerMonitor.monitor);
    }
  }

  public static synchronized ServerMonitorPage addPage(Object obj, String name) {
    ensureFrame();
    ServerMonitorPage page = new ServerMonitorPage(obj);
    ServerMonitor.monitor.addPage(page, name);
    return page;
  }

  public static synchronized void log(String str) {
    if (myLog != null) {
      DateFormat df = DateFormat.getDateTimeInstance(DateFormat.SHORT,
          DateFormat.LONG);
      myLog.append(df.format(new java.util.Date()) + " " + str +
                   System.getProperty("line.separator"));
    }
  }
}
