/**
 * Copyright (c) 2003
 * Template File
 *   ServerApp.java.template
 * IDL Object
 *   javacorba.CustService
 * Generation Date
 *   Sunday, April 27, 2003 6:05:08 AM CDT
 * IDL Source File
 *   /root/JBuilderProjects/JavaCorba/src/javacorba/Customer.idl
 * Abstract
 *   CORBA server application.
 * @version 1.0
 */

package javacorba;

import javacorba.CustService.server.*;
import javax.swing.UIManager;
import java.awt.*;
import org.omg.PortableServer.*;

public class CustServiceServerApp {

  boolean packFrame = false;
  CustomerClientImpl1 myCustomer = new CustomerClientImpl1();

  public CustServiceServerApp() {
    ServerFrame frame = new ServerFrame();

    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();

    }
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation( (screenSize.width - frameSize.width) / 2,
                      (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
      //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
      //UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
      //UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
    }
    catch (Exception ex) {
    }
    new CustServiceServerApp();

    try {
      java.util.ResourceBundle res = java.util.ResourceBundle.getBundle(
          "javacorba.CustService.server.ServerResources");
      String name;

      //(debug support)System.getProperties().put("vbroker.agent.debug", "true");
      //(debug support)System.getProperties().put("vbroker.orb.warn", "2");
      if (System.getProperties().get("vbroker.agent.port") == null) {
        System.getProperties().put("vbroker.agent.port", "14000");
      }
      if (System.getProperties().get("org.omg.CORBA.ORBClass") == null) {
        System.getProperties().put("org.omg.CORBA.ORBClass",
                                   "com.inprise.vbroker.orb.ORB");
      }
      if (System.getProperties().get("org.omg.CORBA.ORBSingletonClass") == null) {
        System.getProperties().put("org.omg.CORBA.ORBSingletonClass",
                                   "com.inprise.vbroker.orb.ORB");
      }

      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, System.getProperties());

      POA poaRoot = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));

      name = "Customer";
      org.omg.CORBA.Policy[] CustomerPolicies = {
          poaRoot.create_lifespan_policy(LifespanPolicyValue.PERSISTENT)
      };
      POA poaCustomer = poaRoot.create_POA(name + "_poa",
                                           poaRoot.the_POAManager(),
                                           CustomerPolicies);
      poaCustomer.activate_object_with_id(name.getBytes(), new CustomerImpl());
      ServerMonitor.log(ServerResources.format(res.getString("created"),
          "CustServiceServerApp.java Customer"));

      poaRoot.the_POAManager().activate();
      ServerMonitor.log(ServerResources.format(res.getString("isReady"),
          "CustServiceServerApp.java CustService"));
      orb.run();
    }
    catch (Exception ex) {
      System.err.println(ex);
    }
  }
  private void jbInit() throws Exception {
  }
}
