package CustService;

import java.lang.*;
import java.util.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

class CustomerClient {
    Vector custIDs;
    ORB orb;
    public CustomerClient(String[] args) {
        try {
	      custIDs = new Vector();
            orb = ORB.init(args, null);
	      org.omg.CORBA.Object objRef = 
       	    orb.resolve_initial_references("NameService");
	      NamingContextExt ncRef = 
        	    NamingContextExtHelper.narrow(objRef);
 
	      // resolve the Object Reference in Naming
            String objRefName = "Customer";
	      Customer custRef = CustomerHelper.narrow(ncRef.resolve_str(objRefName));
	      addCustomers(custRef);
        }
	  catch (Exception e) {
      	  System.out.println("ERROR : " + e) ;
	        e.printStackTrace(System.out);
        }
    }
    public void addCustomers(Customer custRef) {
        try {
		// Add three customer names to the server's list.
		int custId = 0;		
		custId = custRef.AddCustomer("John P Smith");
		custIDs.add(String.valueOf(custId));
		custId = custRef.AddCustomer("David Bayer");
		custIDs.add(String.valueOf(custId));
		custId = custRef.AddCustomer("Susan Blackwill");
		custIDs.add(String.valueOf(custId));

		// Now retrieve the customer names that were added earlier,
		// and display them to the screen.
		for (int i=0; i < custIDs.size(); i++) {
		    String custIdStr = (String)custIDs.get(i);
		    String custName = custRef.GetCustomer(Integer.valueOf(custIdStr).intValue());
		    if ((custName != null) && (custName != "")) {
		        System.out.println("Customer "+custName
				+" has customer id "+custIdStr);			 
		    }
		}
	  } 
	  catch (Exception e) {
      	  System.out.println("ERROR : " + e) ;
	        e.printStackTrace(System.out);
        }
    }
    public static void main(String[] args) {
	  CustomerClient custClient = new CustomerClient(args);
    }
}
