package CustService;

import java.lang.*;
import java.util.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.PortableServer.*;
//import org.omg.PortableServer.POA;
import org.omg.CosNaming.NamingContextPackage.*;

class CustomerServer {
    public static void main (String[] args) {
        try{
            ORB orb = ORB.init(args, null);
            CustomerImpl cust = new CustomerImpl(orb);

		// Create the root POA object, and using it
		// activate the associated POA manager.
		// Once the POA manager is activated, it can
		// manage the associated CORBA objects.
            POA rootpoa = POAHelper.narrow(
              orb.resolve_initial_references("RootPOA"));
            rootpoa.the_POAManager().activate();

            // get object reference from the servant
            org.omg.CORBA.Object custObjRef = 
              rootpoa.servant_to_reference(cust);
            Customer custIntRef = CustomerHelper.narrow(custObjRef);
	  
            // get the root naming context
            // NameService invokes the name service
            org.omg.CORBA.Object objRef = 
              orb.resolve_initial_references("NameService");

            // Use NamingContextExt which is part of the Interoperable
            // Naming Service (INS) specification.
            NamingContextExt ncRef = 
            NamingContextExtHelper.narrow(objRef);

            // bind the Object Reference in Naming
            String name = "Customer";
            NameComponent path[] = ncRef.to_name( name );
            ncRef.rebind(path, custIntRef);

            System.out.println("Customer server started ..."); 
            // wait for invocations from clients
            orb.run();
        } catch (Exception e) {
            System.err.println("ERROR: " + e);
            e.printStackTrace(System.out);
        }
        System.out.println("Customer Server Exiting ....");
	  
    }
}
