import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

public class CurrTimeImpl extends UnicastRemoteObject implements CurrTime {
  Calendar currentTime;
  public CurrTimeImpl(String objectName) throws RemoteException {
    super();
    try {
      currentTime = Calendar.getInstance();
      Naming.rebind(objectName, this);
    }
    catch (Exception e) {
      if (e instanceof RemoteException)
        throw (RemoteException)e;
      else
        throw new RemoteException(e.getMessage());
    }
  }
  public Calendar getCurrentTime() throws RemoteException {
    return currentTime;
  }
  public String getCurrentTimeString() throws RemoteException {
    return currentTime.getTime().toString();
  }
  public void setCurrentTime(Calendar currTime) throws RemoteException {
    currentTime = currTime;
  }
}
