package tcpsockets;
import java.io.*;
import java.util.*;
import java.net.*;

public class ServerThread extends Thread {
  Socket sock;
  ObjectOutputStream ostr;
  ObjectInputStream istr;
  int clientPort;
  String clientIP;
  public ServerThread(Socket newSocket) {
    sock = newSocket;
    try {
      // get the input and output streams from the socket object
      // to perform read and write operations respectively
      ostr = new ObjectOutputStream(sock.getOutputStream());
      istr = new ObjectInputStream(sock.getInputStream());
      clientPort = sock.getPort();
      clientIP = sock.getInetAddress().toString();
      System.out.println("Ready to communicate with client at IP address "
      +clientIP+" and port "+clientPort);
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
 }
 public void run() {
   // It is this run method of the individual thread object that performs
   // the actual communication with the client socket.
   String inMsg = "";
   do {
     try {
       inMsg = (String) istr.readObject();
       StringTokenizer inStrTok = new StringTokenizer(inMsg, "=", false);
       String msgCode = inStrTok.nextToken();
       if (msgCode.equals("NAME")) {
         String clientName = inStrTok.nextToken();
         System.out.println("The client name is "+clientName);
         ostr.writeObject("NAME=Hello "+clientName);
       }
       if (msgCode.equals("TIME")) {
         Calendar currTime = Calendar.getInstance();
         ostr.writeObject("TIME="+currTime.getTime());
       }
     }
     catch (ClassNotFoundException ex) {
       ex.printStackTrace();
       System.exit(-1);
     }
     catch (IOException ex) {
       System.out.println("Error with I/O streams for client at IP address "
                          +clientIP+" and port "+clientPort);
       System.out.println("Terminating client connection...");
       System.exit(-1);
     }
   } while (!inMsg.equals("BYE"));
   System.out.println("Client requested termination from IP address "
                      +clientIP+" and port "+clientPort);
   try {
     sock.shutdownInput();
     sock.shutdownOutput();
     sock.close();
   }
   catch (IOException ex) {
     ex.printStackTrace();
   }
 }
}