package tcpsockets;
import java.io.*;
import java.util.*;
import java.net.*;

public class TCPClient {
  Socket sock;
  InetAddress serverInetAddr;
  String clientName;
  public TCPClient(String clName) {
    try {
      clientName = clName;
      serverInetAddr = InetAddress.getByName("127.0.0.1");
      sock = new Socket(serverInetAddr, 6800);
      System.out.println("Connected to server on "+serverInetAddr.getHostName()+
                         " listening to port "+sock.getPort());
      // get the input and output streams from the socket object
      // to perform read and write operations respectively
      ObjectOutputStream ostr = new ObjectOutputStream(sock.getOutputStream());
      ObjectInputStream istr = new ObjectInputStream(sock.getInputStream());
      ostr.writeObject("NAME="+clientName);

      String inMsg = "";
      while (true) {
        if (sock.isClosed()) {
          System.out.println("Server closed the connection...");
          break;
        }
        if (sock.isInputShutdown()) {
          System.out.println("Input stream is down...");
          break;
        }
        if (sock.isOutputShutdown()) {
          System.out.println("Output stream is down ...");
          break;
        }

        try {
          inMsg = (String) istr.readObject();
          StringTokenizer inStrTok = new StringTokenizer(inMsg, "=", false);
          String msgCode = inStrTok.nextToken();
          if (msgCode.equals("NAME")) {
            ostr.writeObject("TIME=?");
          }
          if (msgCode.equals("TIME")) {
            String currTime = inStrTok.nextToken();
            System.out.println("Current time on the server is "+currTime);
            ostr.writeObject("BYE");
          }
        }
        catch (ClassNotFoundException ex) {
          ex.printStackTrace();
        }
        catch (IOException ex) {
          System.out.println("The socket is closed...");
          System.out.println("Terminating server connection...");
          System.exit( -1);
        }
      };
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
  public static void main(String[] args) {
    if (args.length != 1) {
      System.out.println("Client must specify a name...");
      System.exit(-1);
    }
    String clientName = new String(args[0]);
    System.out.println("Attempting to connet to the TCP server...");
    TCPClient TCPClient1 = new TCPClient(clientName);
  }
}