package udpsockets;
import java.io.*;
import java.util.*;
import java.net.*;

public class UDPServerThread extends Thread {
  int remotePort = 6040;
  public UDPServerThread() {
  }

  public void run() {
    try {
      InetAddress inetAddr = InetAddress.getByName("localhost");
      DatagramSocket dgSocket = new DatagramSocket();
      System.out.println("Message transmission started... ");

      int messageId = 1;
      int messageIdRpt = 1;
      while (true) {
        Calendar currTime = Calendar.getInstance();
        String message = "Message Seq Number "+messageId;
        message += " - current time : ";
        message += currTime.getTime();
        try {
          DatagramPacket dgPacket = new DatagramPacket(message.
              getBytes(), message.length(), inetAddr, remotePort);
          dgSocket.send(dgPacket);
        }
        catch (IOException iox) {
          System.out.println("IO Exception ...");
          System.exit(-1);
        }
        if (messageIdRpt == 50) {
          System.out.println("50 messages sent since last time reporting...");
          messageIdRpt = 1;
          sleep(200);
        }
        else
          messageIdRpt++;
        messageId++;
      }
    }
    catch (InterruptedException iox) {
      System.out.println("Server is interrupted to stop ...");
      System.out.println("Hence stopping the UDP broadcast server ...");
      System.exit(-1);
    }
    catch (UnknownHostException sx) {
      System.out.println("Host unknown ...");
      System.exit(-1);
    }
    catch (SocketException sx) {
      System.out.println("Socket Exception ...");
      System.exit(-1);
    }
  }
}